#{extends 'common/frontend-admin.html' /}
#{set 'title'}
<h1>Profile Pengadaan</h1>
#{/set}
<div class="container">
    <div class="row">
        <div class="col-sm-10">
            <div class="card">
                <div class="card-body">
                    <form method="POST" action="" enctype="multipart/form-data" class="procurement-form">
                        <input type="hidden" name="model.action" value="${action}" >
                        <input type="hidden" name="id" value="${model.id}" class="procurement-id">
                        <div class="form-group" style="margin-left: 25px;">
                            <label class="control-label">Halaman</label>
                            <select class="ui fluid multiple search selection dropdown form-control" id="selectPage">
                                #{list items: pages, as: 'page'}
                                    <option value="${page}">Halaman ${page}</option>
                                #{/list}
                            </select>
                        </div>
                        <div class="divider" style="height: 2px; margin-left: 25px;"></div>
                        <br />
                        %{
                            index = 0
                        }%
                        #{list items:pages, as:'page'}
                        %{
                            array = model.getDataAsMap().get(page)
                        }%
                        <div class="page page-number-${page} ${page_index == 1 ? '' : 'hidden'}" style="margin-left: 25px;">
                            #{list items:array, as:'item' }
                            <div class="form-group">
                                <div class="form-row">
                                    <input type="hidden" name="list[${index}].header" value="${item.getHeader()}">
                                    <input type="hidden" name="list[${index}].extra" value="${item.getExtra()}">
                                    <div class="${item.isMultiple() ? 'col-6' : 'col-12'}">
                                        <label class="control-label">${item.getLabel()}</label>
                                        <div class="input-group-append">
                                            #{if item?.getProfileSection()?.isText()}
                                                <input type="text" data-value="${page}" data-type="text" name="list[${index}].value_text" value="${item.getValueText()}" class="form-control input-value">
                                            #{/if}
                                            #{else}
                                                <input type="text" data-value="${page}" data-type="numeric" name="list[${index}].value" value="${item.getStringifyValue()}" class="form-control input-value number">
                                            #{/else}
                                            <span class="btn button-default button-refresh input-group-text" data-value="${item.getHeader()}"><i class="fa fa-refresh"></i></span>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            %{
                                index++
                            }%
                            #{/list}
                        </div>
                        #{/list}
                        <div class="form-group">
                            <div class="col-sm-12">
                                <div class="pull-right">
                                    <a href='@{index()}' class="btn btn-default">Back</a>
                                    <button type="submit" formaction="#{url route.dashboard_procurementprofile_profilecontroller_storeasdraft /}" class="btn btn-danger btn-save">Draft</button>
                                    <button type="submit" formaction="#{url route.dashboard_procurementprofile_profilecontroller_storeaspublished /}" class="btn btn-success publish">Publish</button>
                                </div>
                            </div>
                        </div>

                    </form>
                </div>
            </div>
        </div>
    </div>
</div>

#{set 'moreScripts'}
<script src="/public/assets/plugins/jquery-autonumeric/autoNumeric.js" type="text/javascript"></script>
<script src="/public/javascripts/location-hash.js" type="text/javascript"></script>
<script type="text/javascript">
        $(document).ready(function() {
            const pages = JSON.parse('${utils.common.JsonUtil.toJson(pages).raw()}')
            const procurementData = JSON.parse('${utils.common.JsonUtil.toJson(model.getData()).raw()}')
            var currentPage = '' + pages[0]
            $(".number").autoNumeric({aSep: '.', aDec: ',', vMax: '999999999999999999', mDec: 0})
            $('#selectPage').change(function(e) {
                var page = $(this).val()
                if (page === null) {
                    page = currentPage
                }
                let selector = '.page-number-' + page
                let container = $(selector)
                updateLibOnLocation(page, 'page')
                container.removeClass('hidden')
                $('.page:not(' + selector + ')').addClass('hidden')
            })

            function getPageIndex(page) {
                let index = pages.findIndex(e => e === page).toString()
                return index
            }

            function showFocus(element) {
                let input = $(element)
                input.parent().addClass('has-error')
                input.focus()
            }

            $(document).on('change', '.input-value', function () {
                let parent = $(this).parent()
                let parentClass = parent.attr('class')
                if (parentClass.includes('has-error')) {
                    parent.removeClass('has-error')
                }
            })

            $('.button-refresh').click(function() {
                let header = $(this).data('value')
                let cleanedHeader = header.replace('.paguValue')
                let procurementId = $('.procurement-id').val()
                let data = procurementData.find(e => e.header === cleanedHeader)
                if (data) {
                    let sibling = $(this).siblings()[0]
                    let type = $(sibling).data('type')
                    if (type === 'numeric' && typeof data.value !== 'undefined') {
                        sibling.value = data.value.toLocaleString('ID')
                    } else if (type === 'text') {
                        sibling.value = data.value_text ? data.value_text : ''
                    }
                }
            })

            readFromUrlAndSetSelected()

            function readFromUrlAndSetSelected() {
                let id = getLibFromLocation('page')
                if (id == 0 || !pages.includes(parseInt(id))) {
                    return
                }
                setSelected(id)
            }

            function setSelected(page) {
                $('#selectPage option[value="' + page + '"]').prop('selected', 'selected')
                $('#selectPage').trigger('change')
            }

            $('.publish').click(function(e) {
                e.preventDefault()
                let elements = [...$('input[type="text"]')]
                for (let element of elements) {
                    if (element.value === '') {
                        let page = $(element).data('value')
                        let currentPageVal = $('#selectPage').val()
                        if (page == currentPageVal) {
                            showFocus(element)
                            return
                        }
                        currentPage = page
                        let index = getPageIndex(currentPage)
                        setSelected(currentPage)
                        showFocus(element)
                        return
                    }
                }
                var formData = new FormData($('.procurement-form')[0])
                var object = {};
                formData.forEach(function(value, key){
                    object[key] = value;
                });
                let action = $(this).attr('formaction')
                $('.procurement-form').prop('action', action).submit()
            })
        })
    </script>
#{/set}
